import { metrics as m } from '@nodeswork/utils';
import * as sMongoose from '../mongoose';
export declare type MetricsModelType = typeof MetricsModel & sMongoose.ModelType;
export declare class MetricsModel extends sMongoose.Model implements m.MetricsData {
    ts: Date;
    dimensions: m.Dimensions;
    metrics: m.Metrics;
    static upsertMetrics(options: SetMetricsOptions): Promise<MetricsModel>;
    appendMetrics(options: MetricsOptions): void;
    static appendMetrics(options: SetMetricsOptions): Promise<MetricsModel>;
    static createMetrics<T extends MetricsModel>(options: CreateMetricsOptions): Promise<T>;
    static searchMetrics<T extends MetricsModel>(options: MetricsSearchOptions): Promise<T[]>;
    static aggregateMetrics(options: AggregateMetricsOptions): Promise<AggregatedMetrics[]>;
}
export interface AggregatedMetrics extends m.MetricsData {
    timerange: {
        start: Date;
        end: Date;
    };
}
export interface CreateMetricsOptions {
    ts?: Date;
    metrics?: MetricsOptions[];
    doc?: object;
}
export interface MetricsOptions {
    dimensions?: m.MetricsDimensions;
    name: string;
    value: m.MetricsValue<any>;
}
export interface MetricsSearchOptions {
    timerange: {
        start: Date;
        end: Date;
    };
    query?: object;
    project?: object;
    queryOptions?: object;
    dimensions?: string | string[];
    metrics?: string | string[];
}
export interface AggregateMetricsOptions extends MetricsSearchOptions {
    ids?: boolean;
    granularityInSecond: number;
}
export interface SetMetricsOptions extends MetricsOptions {
    id: string;
}
